///////////////////////////////////////////////////////////////
// ,    
// 
// (c)  , 2002

class A0 : public Automat  
{
protected:
    virtual void Step(int e); //  
    DECLARE_NO_POSTSTEP; // ,       

public:
    virtual void WriteLog(CString s,int indent=0); //     s (indent - )
protected:
    virtual void WriteLogOnStart(int y,int e,int indent=0);            //      ,      e (indent - )
    virtual void WriteLogOnStateChanged(int y,int y_old,int indent=0); //      ,      y_old  y (indent - )
	virtual void WriteLogOnFinish(int y,int indent=0);                 //      ,       y (indent - )

//  
public:
    typedef enum StateValuesType {NEUTRAL, GOINGUP, GOINGDOWN} StateValues; //   
    typedef struct CallsStoreType
    {
        int up[5],down[5],car[5];
		bool newcalls;
    } CallsStore; //  ,   

// 
public:
    unsigned floor;      //  
    unsigned timer;      // 
	int inactivitytimer; //  
    CallsStore calls;    //  
    StateValues state;   //  

// A,     
public:
    A1 aA1; //  A1
    A2 aA2; //  A2

// 
public:
    const static int e0; // 	   , 
    const static int e1; //   

//  
protected:
	// ,    
	int x1_0();           //      () ?

	// ,    
    int x2_0();           //       ?
	int x2_1();           //     (  )?

    // ,    
    int x3_0();           //   - NEUTRAL
    int x3_1();           //   - GOINGUP
    int x3_2();           //   - GOINGDOWN

    // ,   
    int x4_0();           //  ?

    // ,    
    int x5_0();           //   ?

//  
protected:
    //   
    void z1_0();           //      2
    void z1_1();           //      1
    void z1_2();           //      1

    //    
    void z2_0();           //   
    void z2_1();           //      

    //    
    void z3_0();           //   NEUTRAL
	void z3_1();           //  ,   
	void z3_2();           //     () 

    //   
    void z4_0(unsigned n); //     n

	//    
	void z5_0();           //   
	void z5_1();           //   
	void z5_2();           //   ,    

//  
private:
	// ,    
	StateValues i3_0();    //    ,   
};